
/********************************** (C) COPYRIGHT *******************************
* File Name          :CompositeKM.C
* Author             : WCH
* Version            : V1.2 
* Date               : 2018/02/28
* Description        : CH559ģUSB豸֧,ֻ֧
* other
  *8ֽڱʾ
  *4ֽڱʾ
  *͸
*******************************************************************************/

#include "./Public/CH554.H"                                                      
#include "./Public/Debug.H"
#include <string.h>
#include <stdio.h>

#define Single_Port             0xBB
//#define Double_Port             0xAA
#define Fullspeed               1

#ifdef  Fullspeed
#define THIS_ENDP0_SIZE         64
#else
#define THIS_ENDP0_SIZE         8  //USBжϴ䡢ƴΪ8
#endif

#define ERROR_LEN  0xFFFF

#define u8_mouse 0x30
#define u8_key   0x31
#define u8_media 0x35 

#define u8_mouse_len 4
#define u8_key_len   8

UINT8X  Ep0Buffer[192] _at_ 0x0000;    //˵0 OUT&INżַ+˵4IN&OUT
UINT8X  Ep1Buffer[8] _at_ 0x00C2;  //˵1 IN,żַ
UINT8X  Ep2Buffer[4] _at_ 0x00CE;  //˵2 IN,żַ
UINT8X  Ep3Buffer[8] _at_ 0x00D6;  //˵3 IN,żַ
UINT8   SetupReq,SetupLen,Ready,Count,Ep1FLAG,Ep2FLAG,Ep3FLAG,Ep4FLAG,UsbConfig;
UINT8   Ep4BufFree;
PUINT8  pDescr;                                                                //USBñ־
USB_SETUP_REQ   SetupReqBuf;                                                   //ݴSetup
sbit Ep2InKey = P1^5;
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
#define DEBUG 0
#pragma  NOAREGS
/*豸*/
UINT8C DevDesc[18] = {0x12,0x01,0x10,0x01,0x00,0x00,0x00,THIS_ENDP0_SIZE,
                      0x32,0x41,0x07,0x21,0x00,0x00,0x00,0x00,
                      0x00,0x01
                     };
UINT8C CfgDesc[116] =
{
    0x09,0x02,0x74,0x00,0x04,0x01,0x00,0xA0,0x32,             //
    0x09,0x04,0x00,0x00,0x01,0x03,0x01,0x01,0x00,             //ӿ,
    0x09,0x21,0x11,0x01,0x00,0x01,0x22,0x3e,0x00,             //HID
    0x07,0x05,0x81,0x03,0x08,0x00,0x0a,                       //˵
    0x09,0x04,0x01,0x00,0x01,0x03,0x01,0x02,0x00,             //ӿ,
    0x09,0x21,0x10,0x01,0x00,0x01,0x22,0x34,0x00,             //HID
    0x07,0x05,0x82,0x03,0x04,0x00,0x0a,                        //˵
    0x09, 0x04, 0x02, 0x00, 0x01, 0x03, 0x00, 0x00, 0x00,      //ӿ,ý
    0x09, 0x21, 0x10, 0x01, 0x00, 0x01, 0x22, 0x63, 0x00,      //HID
    0x07, 0x05, 0x83, 0x03, 0x08, 0x00, 0x0A,                   //˵жϴ
    0x09,0x04,0x03,0x00,0x02,0x03,0x00,0x00,0x05,               //ӿ
    0x09,0x21,0x00,0x01,0x00,0x01,0x22,0x22,0x00,               //HID
#ifdef  Fullspeed	
    0x07,0x05,0x84,0x03,THIS_ENDP0_SIZE,0x00,0x01,              //˵(ȫټʱĳ1ms)
    0x07,0x05,0x04,0x03,THIS_ENDP0_SIZE,0x00,0x01,              //˵
#else
    0x07,0x05,0x84,0x03,THIS_ENDP0_SIZE,0x00,0x0A,              //˵(ټʱС10ms)
    0x07,0x05,0x04,0x03,THIS_ENDP0_SIZE,0x00,0x0A              //˵
#endif	
};
/*ַ*/
/*HID౨*/
UINT8C KeyRepDesc[62] =
{
    0x05,0x01,0x09,0x06,0xA1,0x01,0x05,0x07,
    0x19,0xe0,0x29,0xe7,0x15,0x00,0x25,0x01,
    0x75,0x01,0x95,0x08,0x81,0x02,0x95,0x01,
    0x75,0x08,0x81,0x01,0x95,0x03,0x75,0x01,
    0x05,0x08,0x19,0x01,0x29,0x03,0x91,0x02,
    0x95,0x05,0x75,0x01,0x91,0x01,0x95,0x06,
    0x75,0x08,0x26,0xff,0x00,0x05,0x07,0x19,
    0x00,0x29,0x91,0x81,0x00,0xC0
};
UINT8C MouseRepDesc[52] =
{
    0x05,0x01,0x09,0x02,0xA1,0x01,0x09,0x01,
    0xA1,0x00,0x05,0x09,0x19,0x01,0x29,0x03,
    0x15,0x00,0x25,0x01,0x75,0x01,0x95,0x03,
    0x81,0x02,0x75,0x05,0x95,0x01,0x81,0x01,
    0x05,0x01,0x09,0x30,0x09,0x31,0x09,0x38,
    0x15,0x81,0x25,0x7f,0x75,0x08,0x95,0x03,
    0x81,0x06,0xC0,0xC0
};
/*HID౨*/
UINT8C HIDRepDesc[ ] =
{
    0x06, 0x00,0xff,
    0x09, 0x01,
    0xa1, 0x01,                                                   //Ͽʼ
    0x09, 0x02,                                                   //Usage Page  ÷
    0x15, 0x00,                                                   //Logical  Minimun
    0x26, 0x00,0xff,                                              //Logical  Maximun
    0x75, 0x08,                                                   //Report Size
    0x95, THIS_ENDP0_SIZE,                                        //Report Counet
    0x81, 0x06,                                                   //Input
    0x09, 0x02,                                                   //Usage Page  ÷
    0x15, 0x00,                                                   //Logical  Minimun
    0x26, 0x00,0xff,                                              //Logical  Maximun
    0x75, 0x08,                                                   //Report Size
    0x95, THIS_ENDP0_SIZE,                                        //Report Counet
    0x91, 0x06,                                                   //Output
    0xC0
};
UINT8C KeyMediaRepDesc[99] ={
0x05, 0x0C, 0x09, 0x01, 0xA1, 0x01, 
0x85, 0x01, 0x05, 0x0C, 0x19, 0x00, 0x2A, 0xFF, 0x03, 
0x95, 0x01, 0x75, 0x10, 0x15, 0x00, 0x26, 0xFF, 0x03, 0x81, 0x00,
0x05, 0x07, 0x19, 0x00, 0x29, 0xFF, 0x75, 0x08, 0x26, 0xFF, 0x00, 0x81, 0x00, 0x81, 0x01, 
0x06, 0x00, 0xFF, 0x0A, 0x03, 0xFE, 0x0A, 0x04, 0xFE, 0x75, 0x01, 0x95, 0x02, 0x25, 0x01, 0x81, 0x02,
0x0A, 0x05, 0xFF, 0x95, 0x01, 0x75, 0x05, 0x25, 0x1F, 0x81, 0x02, 
0x75, 0x01, 0x81, 0x01, 0x1A, 0x01, 0xFD, 0x2A, 0xFF, 0xFD, 0x15, 0x01, 
0x26, 0xFF, 0x00, 0x75, 0x08, 0x81, 0x00, 0x0A, 0x02, 0xFF, 0x26, 0xFF, 0x00, 0x15, 0x00, 0x81, 0x02, 0xC0
};

/*******************************************************************************
* Function Name  : CH554SoftReset()
* Description    : CH554λ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH554SoftReset( )
{
    SAFE_MOD = 0x55;
    SAFE_MOD = 0xAA;
    GLOBAL_CFG	|=bSW_RESET;
}

/*******************************************************************************
* Function Name  : CH554USBDevWakeup()
* Description    : CH554豸ģʽKź
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH554USBDevWakeup( )
{
#ifdef Fullspeed
	UDEV_CTRL |= bUD_LOW_SPEED;
	mDelaymS(2);
	UDEV_CTRL &= ~bUD_LOW_SPEED;		
#else
	UDEV_CTRL &= ~bUD_LOW_SPEED;
	mDelaymS(2);
	UDEV_CTRL |= bUD_LOW_SPEED;	
#endif
}

/*******************************************************************************
* Function Name  : USBDeviceInit()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceInit()
{
	IE_USB = 0;
	USB_CTRL = 0x00;                                                           // 趨USB豸ģʽ
	UDEV_CTRL = bUD_PD_DIS;                                                    // ֹDP/DM
#ifndef Fullspeed
    UDEV_CTRL |= bUD_LOW_SPEED;                                                //ѡ1.5Mģʽ
    USB_CTRL |= bUC_LOW_SPEED;
#else
    UDEV_CTRL &= ~bUD_LOW_SPEED;                                               //ѡȫ12MģʽĬϷʽ
    USB_CTRL &= ~bUC_LOW_SPEED;
#endif
	
    UEP2_DMA = Ep2Buffer;                                                      //˵2ݴַ
    UEP2_3_MOD = UEP2_3_MOD & ~bUEP2_BUF_MOD | bUEP2_TX_EN;                    //˵2ʹ 64ֽڻ
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK;                                 //˵2Զתͬ־λIN񷵻NAK

    UEP3_DMA = Ep3Buffer;                                                      //˵3ݴַ
    UEP2_3_MOD = UEP2_3_MOD & ~bUEP3_BUF_MOD | bUEP3_TX_EN;                    //˵3ʹ 64ֽڻ
    UEP3_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK;                                 //˵3Զתͬ־λIN񷵻NAK

    UEP0_DMA = Ep0Buffer;                                                      //˵0ݴַ
    UEP4_1_MOD |= bUEP4_RX_EN | bUEP4_TX_EN;                                   //˵064ֽշ,˵4 IN&OUT64
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK
    UEP4_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK

    UEP1_DMA = Ep1Buffer;                                                      //˵1ݴַ
    UEP4_1_MOD = UEP4_1_MOD & ~bUEP1_BUF_MOD | bUEP1_TX_EN;                    //˵1ʹ 64ֽڻ
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK;                                 //˵1Զתͬ־λIN񷵻NAK	
		
	USB_DEV_AD = 0x00;			
	USB_CTRL |= bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;                     // USB豸DMAжڼжϱ־δǰԶNAK
	UDEV_CTRL |= bUD_PORT_EN;                                                  // USB˿
	USB_INT_FG = 0xFF;                                                         // жϱ־
	USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
	IE_USB = 1;
}
/*******************************************************************************
* Function Name  : Enp1IntIn()
* Description    : USB豸ģʽ˵1жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp1IntIn(UINT8 len)
{
    UEP1_T_LEN = len;                                             //ϴݳ
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                //ʱϴݲӦACK
}
/*******************************************************************************
* Function Name  : Enp2IntIn()
* Description    : USB豸ģʽ˵2жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp2IntIn(UINT8 len )
{
    UEP2_T_LEN = len;                                              //ϴݳ
    UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                  //ʱϴݲӦACK
}

void Enp3IntIn(UINT8 len )
{
    UEP3_T_LEN = len;                                              //ϴݳ
    UEP3_CTRL = UEP3_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                  //ʱϴݲӦACK
}
/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH559USBжϴ
*******************************************************************************/
void    DeviceInterrupt( void ) interrupt INT_NO_USB using 1                      //USBжϷ,ʹüĴ1
{
    UINT16 len;
	len = 0;
    if(UIF_TRANSFER)                                                            //USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_IN | 3:                                                  //endpoint 3# ж϶˵ϴ
            UEP3_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
            UEP3_CTRL = UEP3_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            Ep3FLAG = 1;                                                           /*ɱ־*/
            break;
        case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ж϶˵ϴ
            UEP2_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
            UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            Ep2FLAG = 1;                                                           /*ɱ־*/
            break;
        case UIS_TOKEN_IN | 1:                                                  //endpoint 1# ж϶˵ϴ
            UEP1_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
            UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            Ep1FLAG = 1;                                                        /*ɱ־*/
            break;
        case UIS_TOKEN_IN | 4:                                                  //endpoint 4# ж϶˵ϴ
            UEP4_CTRL ^= bUEP_T_TOG;                                             //ֶתͬ־λ			 			
            UEP4_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
            UEP4_CTRL = UEP4_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            Ep4FLAG = 1;                                                        /*ɱ־*/
            break;
        case UIS_TOKEN_OUT | 4:                                                  //endpoint 4# ж϶˵´                                                  
            UEP4_CTRL ^= bUEP_R_TOG;                                             //ֶתͬ־λ			 			
            UEP4_CTRL = UEP4_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_NAK;            //ĬӦNAK
            if(USB_RX_LEN == 8)
            {
              Ep4BufFree = u8_key;
              memcpy(Ep1Buffer,&Ep0Buffer[64],8);
            }
            else if(USB_RX_LEN == 4)
            {
              Ep4BufFree = u8_mouse;
              memcpy(Ep2Buffer,&Ep0Buffer[64],4);
            }
            else if(USB_RX_LEN == 9)
            {
              Ep4BufFree = u8_media;
              memcpy(Ep3Buffer,&Ep0Buffer[64],8);
            }						
        case UIS_TOKEN_SETUP | 0:                                                //SETUP
            len = USB_RX_LEN;
            if(len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthH;
                SetupLen <<= 8;
                SetupLen |= UsbSetupBuf->wLengthL;
                if(SetupLen >= (ERROR_LEN-1) )
                {
                    SetupLen = ERROR_LEN;    // ܳ
                }
                len = 0;                                                        // ĬΪɹϴ0
                SetupReq = UsbSetupBuf->bRequest;								
                if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )/* HID */
                {
					switch( SetupReq ) 
					{
						case 0x01://GetReport
							break;
						case 0x02://GetIdle
							break;	
						case 0x03://GetProtocol
							break;				
						case 0x09://SetReport										
							break;
						case 0x0A://SetIdle
							break;	
						case 0x0B://SetProtocol
							break;
						default:
							len = ERROR_LEN;  								   /*֧*/					
							break;
					}	
                }
                else
                {                                                           //׼
                    switch(SetupReq)                                        //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch(UsbSetupBuf->wValueH)
                        {
                        case 1:                                             //豸
                            pDescr = DevDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case 2:                                             //
                            pDescr = CfgDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
                        case 0x22:                                          //
                            if(UsbSetupBuf->wIndexL == 0)                   //ӿ0
                            {
                                pDescr = KeyRepDesc;                        //׼ϴ
                                len = sizeof(KeyRepDesc);
                            }
                            else if(UsbSetupBuf->wIndexL == 1)              //ӿ1
                            {
                                pDescr = MouseRepDesc;                      //׼ϴ
                                len = sizeof(MouseRepDesc);                                
                            }
                            else if(UsbSetupBuf->wIndexL == 3)              //ӿ1
                            {
                                pDescr = HIDRepDesc;                      //׼ϴ
                                len = sizeof(HIDRepDesc);                                
                            }
                            else if(UsbSetupBuf->wIndexL == 2)              //ӿ1
                            {
                                pDescr = KeyMediaRepDesc;                      //׼ϴ
                                len = sizeof(KeyMediaRepDesc);                                
                            }
                            else
                            {
                                len = ERROR_LEN;                                 //ֻ2ӿڣ仰ִ
                            }
                            break;
                        default:
                            len = ERROR_LEN;                                     //ֵ֧߳
                            break;
                        }
                        if ( SetupLen > len )
                        {
                            SetupLen = len;    //ܳ
                        }
                        len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; //δ䳤
                        memcpy(Ep0Buffer,pDescr,len);                        //ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;                     //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if ( SetupLen >= 1 )
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
						if(UsbConfig)
						{
							Ready = 1;                                      //set configһusböɵı־
						}
						break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                            //Clear Feature
                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                        {
                            switch( UsbSetupBuf->wIndexL )
                            {
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x01:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                break;
                            default:
                                len = ERROR_LEN;                                            // ֵ֧Ķ˵
                                break;
                            }
                        }
                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )// 豸
                        {
							break;
                        }													
                        else
                        {
                            len = ERROR_LEN;                                                // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                                              /* Set Feature */
                        if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x00 )             /* 豸 */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x01 )
                            {
                                if( CfgDesc[ 7 ] & 0x20 )
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = ERROR_LEN;                                        /* ʧ */
                                }
                            }
                            else
                            {
                                len = ERROR_LEN;                                            /* ʧ */
                            }
                        }
                        else if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x02 )        /* ö˵ */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x00 )
                            {
                                switch( ( ( UINT16 )UsbSetupBuf->wIndexH << 8 ) | UsbSetupBuf->wIndexL )
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                                    break;
                                default:
                                    len = ERROR_LEN;                               //ʧ
                                    break;
                                }
                            }
                            else
                            {
                                len = ERROR_LEN;                                   //ʧ
                            }
                        }
                        else
                        {
                            len = ERROR_LEN;                                      //ʧ
                        }
                        break;
                    case USB_GET_STATUS:
                        Ep0Buffer[0] = 0x00;
                        Ep0Buffer[1] = 0x00;
                        if ( SetupLen >= 2 )
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = ERROR_LEN;                                           //ʧ
                        break;
                    }
                }
            }
            else
            {
                len = ERROR_LEN;                                                   //ȴ
            }
            if(len == ERROR_LEN)
            {
                SetupReq = ERROR_LEN;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
            }
            else if(len)                                                //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
            }
            else
            {
                UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
            }
            break;
        case UIS_TOKEN_IN | 0:                                               //endpoint0 IN
            switch(SetupReq)
            {
            case USB_GET_DESCRIPTOR:
                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;    //δ䳤
                memcpy( Ep0Buffer, pDescr, len );                            //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                                     //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                              //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
            len = USB_RX_LEN;
            if(SetupReq == 0x09)
            {				
            }
            UEP0_CTRL ^= bUEP_R_TOG;                                     //ͬ־λת						
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                                 //д0ж
    }
    if(UIF_BUS_RST)                                                       //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                 //жϱ־
    }
    if (UIF_SUSPEND)                                                     //USB߹/
    {
        UIF_SUSPEND = 0;
        if ( USB_MIS_ST & bUMS_SUSPEND )                                 //
        {
        }
    }
    else {                                                               //ж,ܷ
        USB_INT_FG = 0xFF;                                               //жϱ־
    }
}
void HIDValueHandle()
{
#ifdef Single_Port
    if(Ep4BufFree==u8_mouse)
    {
      Ep2FLAG = 0;
      Enp2IntIn(u8_mouse_len);
      while(Ep2FLAG == 0);
    }
    if(Ep4BufFree==u8_key)
    {
      Ep1FLAG = 0;
      Enp1IntIn(u8_key_len);
      while(Ep1FLAG == 0);
    }
    if(Ep4BufFree==u8_media)
    {
      Ep3FLAG = 0;
      Enp3IntIn(u8_key_len);
      while(Ep3FLAG == 0);
      Ep3FLAG = 0;
      Ep3Buffer[1] = 0;
      Enp3IntIn(u8_key_len);
      while(Ep3FLAG == 0);			
    }		
#endif
#ifdef Double_Port
    if(Ep4BufFree==u8_mouse)
    {

    }
    if(Ep4BufFree==u8_key)
    {
      Ep1FLAG = 0;
      Enp1IntIn(u8_key_len);
      while(Ep1FLAG == 0);
    }
#endif
    Ep4BufFree = 0;
    UEP4_CTRL = UEP4_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_ACK;            //ĬӦNAK		
}

main()
{
    CfgFsys( );                                                           //CH559ʱѡ
    mDelaymS(5);                                                          //޸Ƶȴڲȶ,ؼ	
    mInitSTDIO( );                                                        //0ʼ
#ifdef DE_PRINTF
    printf("start ...\n");
#endif
 
    USBDeviceInit();                                                      //USB豸ģʽʼ
    EA = 1;                                                               //Ƭж
    UEP1_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    UEP2_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    Ep1FLAG = 0; Ep2FLAG = 0;Ep3FLAG = 0;Ep4FLAG = 0;
    Ready = 0;
    Ep4BufFree = 0;
    CH554WDTModeSelect(1);
    while(1)
    {
        if(Ready)
        {
            HIDValueHandle();                                             //úһֱȴڽһֽ
        }
        CH554WDTFeed(0);
    }
}




